-- ͻ
--   S Y N T A X - C O L O R  
-- Ķ
--  Diese Routinen werden zur mehrfarbigen Anzeige von Euphoria- 
--  Programmen benutzt. Der Editor 'ed.ex' und das Druckprogramm 
--  'eprint.ex' benutzen beide diese Datei.                      
--                                                               
--  Diese Datei setzt voraus, da folgende Variablen bereits     
--  definiert worden sind:                                       
--                                                               
--    SCREEN, FORE_COL, COMMENT_COL, KEYWORD_COL, BUILTIN_COL,   
--    STRING_COL, BRACKET_COL                                    
-- ͼ

global sequence builtins
global sequence keywords
global sequence specials

-- Ŀ
--  RESERVIERTE WORTE UND INTERNE ROUTINEN                       
-- 
global procedure set_keywords()

if lang = ex then
-- Ŀ
--  FR EUPHORIA                                                 
-- 
  keywords= {
    "if", "end", "then", "procedure", "else", "for", "return",
    "do", "elsif", "while", "type", "constant", "to", "and", "or",
    "exit", "function", "global", "by", "not", "include",
    "with", "without"}
  builtins= {
    "length", "puts", "integer", "sequence", "position", "object",
    "append", "prepend", "print", "printf", 
    "clear_screen", "floor", "getc", "gets", "get_key",
    "rand", "repeat", "atom", "compare", "find", "match",
    "time", "command_line", "open", "close", "trace", "getenv",
    "sqrt", "sin", "cos", "tan", "log", "system", "date", "remainder",
    "power", "machine_func", "machine_proc", "abort", "peek", "poke", 
    "call", "sprintf", "arctan", "and_bits", "or_bits", "xor_bits",
    "not_bits", "pixel", "get_pixel", "mem_copy", "mem_set",
    "c_proc", "c_func", "routine_id", "call_proc", "call_func", 
    "poke4", "peek4s", "peek4u"}
  specials= {}
elsif lang = asm then
-- Ŀ
--  FR 68K ASSEMBLER                                            
-- 
  keywords= {
    "A0", "A1", "A2", "A3", "A4", "A5", "A6", "A7", "D0", "D1", "D2", "D3",
    "D4", "D5", "D6", "D7", "ABCD", "ADD", "ADDA", "ADDQ", "ADDI", "ADDX",
    "AND", "ANDI", "ASL", "ASR", "BCHG", "BCLR", "BRA", "BCC", "BCS", "BEQ",
    "BGE", "BGT", "BHI", "BLE", "BLS", "BLT", "BMI", "BNE", "BPL", "BVC",
    "BVS", "BSET", "BSR", "BTST", "CCR", "CHK", "CLR", "CMP", "CMPA",
    "CMPM", "CMPI", "DBRA", "DBF", "DBCC", "DBCS", "DBEQ", "DBGE", "DBGT",
    "DBHI", "DBLE", "DBLS", "DBLT", "DBMI", "DBNE", "DBPL", "DBT", "DBVC",
    "DBVS", "DIVS", "DIVU", "EOR", "EORI", "EXG", "EXT", "JMP", "JSR", "LEA",
    "LINK", "LSL", "LSR", "MOVE", "MOVEA", "MOVEC", "MOVEM", "MOVEP",
    "MOVEQ", "MOVES", "FROM", "MULS", "MULU", "NBCD", "NEG", "NEGX", "NOP",
    "NOT", "OR", "ORI", "PEA", "RESET", "ROL", "ROR", "ROXL", "ROXR", "RTD",
    "RTE", "RTR", "RTS", "SCC", "SCS", "SLS", "SEQ", "SF", "SGE", "SGT",
    "SHI", "SLE", "SLS", "SLT", "SMI", "SNE", "SPL", "ST", "SVC", "SVS",
    "SBCD", "SR", "STOP", "SUB", "SUBA", "SUBI", "SUBQ", "SUBX", "SWAP",
    "TAS", "TO", "TRAP", "TRAPV", "TST", "UNLK"}
  builtins= {
    "SP", "PC", "LISTING", "ON", "OFF", "IF", "ENDIF", "MOMPASS", "PADDING",
    "B", "W", "S", "L", "PAGE", "INCLUDE", "MACRO", "ENDM", "SET", "EQU",
    "DS", "DC", "END", "READ", "ELSEIF", "CPU", "ORG", "MACEXP"}
  specials= {}
elsif lang = bas then
-- Ŀ
--  FR ZBASIC                                                   
-- 
  keywords= {
    "LONG", "FN", "END", "IF", "THEN", "ELSE", "XELSE", "WHILE", "WEND",
    "FOR", "TO", "DO", "UNTIL", "NEXT", "GOTO", "GOSUB", "FN", "USR", "DEF",
    "CALL", "SELECT", "CASE", "LET", "RETURN", "MACHLG", "TRON", "TROFF",
    "DEFSTR", "DEFINT", "DEFDBL", "DEFSNG", "ON"}
  builtins= {
    "COLOR", "PLOT", "CLS", "RANDOM", "DATA", "INPUT", "DIM", "READ",
    "RUN", "RESTORE", "STOP", "FILL", "SWAP", "SOUND", "OUT", "OPEN",
    "ROUTE", "RATIO", "CIRCLE", "CLOSE", "LOCATE", "WIDTH", "KILL", "LINE",
    "BOX", "RECORD", "MODE", "LPRINT", "POKE", "PRINT", "WRITE", "DELAY",
    "RENAME", "CLEAR", "BLOAD", "BSAVE", "PALETTE", "COORDINATE", "GET",
    "PUT", "WAIT", "CHDIR", "RANDO", " PAINT", "RESET", "SHELL", "SYSTEM",
    "COMMON", "GREG&RON", "NAME", "MKDIR", "RMDIR", "KEY", "COM", "BEEP",
    "FILES", "TFORMAT", "VIEW", "CURSOR", "ABS", "FRAC", "INT", "MOD",
    "SGN", "SIN", "COS", "TAN", "ATN", "EXP", "LOG", "SQR", "INKEY$",
    "LEN", "VAL", "ASC", "CHR$", "VARPTR", "BIN$", "HEX$", "OCT$", "LEFT$",
    "MID$", "RIGHT$", "PSTR$", "UCASE$", "INSTR", "OR", "AND", "XOR"}
  specials= {"$", "!", "#", "&"}
elsif lang = ps then
-- Ŀ
--  FR POSTSCRIPT                                               
-- 
  keywords= {
    "begin", "bind", "def", "if", "ifelse", "for", "repeat", "loop",
    "exit", "end", "type", "start", "stop", "status", "exch", "clear",
    "pop", "dup", "copy", "index", "roll"}
  builtins= {
    "abs", "add", "aload", "anchorsearch", "and",
    "arc", "arcn", "arcto", "array", "ashow", "astore", "atan", "awidthshow",
    "banddevice", "bitshift", "bytesavailable",
    "cachestatus", "ceiling", "charpath", "cleartomark", "clip",
    "clippath", "closefile", "closepath", "concat", "concatmatrix",
    "copypage", "copyright", "cos", "count", "countdictstack", "countexecstack",
    "counttomark", "currentdash", "currentdict", "currentfile", "currentflat",
    "currentfont", "currentgray", "currenthsbcolor", "currentlinecap",
    "currentlinejoin", "currentlinewidth", "currentmatrix",
    "currentmiterlimit", "currentpoint", "currentrgbcolor", "currentscreen",
    "currenttransfer", "curveto", "cvi", "cvlit", "cvn", "cvr", "cvrs", "cvs",
    "cvx", "defaultmatrix", "definefont", "dict", "dictfull",
    "dictstack", "dictstackoverflow", "dictstackunderflow", "div",
    "dtransform", "echo", "eoclip", "eofill", "eq", "erasepage",
    "errordict", "exec", "execstack", "execstackoverflow",
    "executeonly", "exp", "false", "file", "fill", "findfont",
    "flattenpath", "floor", "flush", "flushfile", "FontDirectory",
    "forall", "framedevice", "ge", "get", "getinterval", "grestore",
    "grestoreall", "gsave", "gt", "handleerror", "identmatrix", "idiv",
    "idtransform", "image", "imagemask",
    "initclip", "initgraphics", "initmatrix", "interrupt", "invalidaccess",
    "invalidexit", "invalidfileaccess", "invalidfont", "invalidrestore",
    "invertmatrix", "ioerror", "itransform", "known", "kshow", "le", "length",
    "limitcheck", "lineto", "ln", "load", "log", "lt", "makefont",
    "mark", "matrix", "maxlength", "mod", "moveto", "mul", "ne", "neg",
    "newpath", "noaccess", "nocurrentpoint", "not", "null", "nulldevice",
    "or", "pathbbox", "pathforall", "print", "prompt", "pstack",
    "put", "putinterval", "quit", "rand", "rangecheck", "rcheck",
    "rcurveto", "read", "readhexstring", "readline", "readonly", "readstring",
    "renderbands", "resetfile", "restore", "reversepath", "rlineto",
    "rmoveto", "rotate", "round", "rrand", "run", "save", "scale",
    "scalefont", "search", "setcachedevice", "setcachelimit", "setcharwidth",
    "setdash", "setflat", "setfont", "setgray", "sethsbcolor", "setlinecap",
    "setlinejoin", "setlinewidth", "setmatrix", "setmiterlimit",
    "setrgbcolor", "setscreen", "settransfer", "show", "showpage", "sin",
    "sqrt", "srand", "stack", "stackoverflow", "stackunderflow",
    "StandardEncoding", "stopped", "store",
    "string", "stringwidth", "stroke", "strokepath", "sub", "syntaxerror",
    "systemdict", "timeout", "token", "transform", "translate", "true",
    "truncate", "typecheck", "undefined", "undefinedfilename",
    "undefinedresult", "unmatchedmark", "unregistered", "userdict",
    "usertime", "version", "VMerror", "vmstatus", "wcheck", "where",
    "widthshow", "write", "writehexstring", "writestring", "xcheck", "xor"}
  specials= {"/"}
elsif lang = pas then
-- Ŀ
--  FR TURBO-PASCAL                                             
-- 
  keywords= {
    "absolute", "and", "array", "asm", "begin", "case", "const", "div",
    "do", "downto", "else", "end", "external", "file", "for", "forward",
    "function", "goto", "if", "implementation", "in", "inline", "interface",
    "interrupt", "label", "mod", "nil", "not", "of", "packed", "procedure",
    "program", "record", "repeat", "set", "shl", "shr", "then",
    "to", "type", "unit", "until", "uses", "var", "while", "with", "xor",
    "break", "continue", "exit", "halt", "runerror"}
  builtins= {
    "chr", "ord", "round", "trunc", "abs", "arctan", "cos", "exp", "frac",
    "int", "ln", "pi", "sin", "sqr", "sqrt", "dec", "inc", "high", "low",
    "odd", "pred", "succ", "concat", "copy", "delete", "insert", "length",
    "pos", "str", "val", "dispose", "freemem", "getmem", "mark", "maxavail",
    "memavail", "new", "release", "addr", "cseg", "dseg", "ofs", "ptr",
    "seg", "sptr", "sseg", "fillchar", "hi", "lo", "move", "paramcount",
    "paramstr", "random", "randomize", "sizeof", "swap", "upcase", "assign",
    "chdir", "close", "eof", "erase", "getdir", "ioresult", "mkdir",
    "rename", "reset", "rewrite", "rmdir", "append", "eoln", "flush", "read",
    "readln", "seekeof", "seekeoln", "settextbuf", "write", "writeln",
    "blockread", "blockwrite", "filepos", "filesize", "seek", "truncate",
    "real", "single", "double", "extended", "comp", "integer", "shortint",
    "longint", "byte", "word", "false", "true", "string", "char"}
  specials = {"@", "$", "#"}
end if
end procedure

set_keywords()

-- Ŀ
--  ZEICHEN-KLASSEN                                              
-- 
constant DIGIT = 1,
         OTHER = 2,
         LETTER  = 3,
         BRACKET = 4,
         QUOTE   = 5,
         DASH = 6,
         WHITE_SPACE = 7,
         NEW_LINE = 8,
         SPECIAL = 9

sequence char_class

-- Ŀ
--  Erzeuge Zeichen-Klassen fr einfacheres Zeilen-Scannen.      
--  Voraussetzung: Keine 0-Zeichen                               
-- 
global procedure init_class()

    char_class = repeat(OTHER, 255)

    char_class['a'..'z'] = LETTER
    char_class['A'..'Z'] = LETTER
    char_class['_'] = LETTER
    char_class['0'..'9'] = DIGIT
    char_class[' '] = WHITE_SPACE
    char_class['\t'] = WHITE_SPACE
    char_class['\n'] = NEW_LINE
    if lang = ex then                           -- EUPHORIA
      char_class['['] = BRACKET
      char_class[']'] = BRACKET
      char_class['('] = BRACKET
      char_class[')'] = BRACKET
      char_class['{'] = BRACKET
      char_class['}'] = BRACKET
      char_class['\''] = QUOTE
      char_class['"'] = QUOTE
      char_class['-'] = DASH
    elsif lang = asm then                       -- 68k ASSEMBLER
      char_class['['] = BRACKET
      char_class[']'] = BRACKET
      char_class['('] = BRACKET
      char_class[')'] = BRACKET
      char_class['\''] = QUOTE
      char_class['"'] = QUOTE
      char_class[';'] = DASH
      char_class['*'] = DASH
      char_class['.'] = SPECIAL
      char_class['#'] = SPECIAL
      char_class['$'] = SPECIAL
    elsif lang = bas then                       -- ZBASIC
      char_class['('] = BRACKET
      char_class[')'] = BRACKET
      char_class['\''] = DASH
      char_class['"'] = QUOTE
      char_class['&'] = SPECIAL
      char_class['!'] = SPECIAL
      char_class['#'] = SPECIAL
      char_class['$'] = SPECIAL
    elsif lang = ps then                        -- POSTSCRIPT
      char_class['('] = QUOTE
      char_class[')'] = QUOTE
      char_class['{'] = SPECIAL
      char_class['}'] = SPECIAL
      char_class['['] = SPECIAL
      char_class[']'] = SPECIAL
      char_class['/'] = SPECIAL
      char_class['='] = SPECIAL
      char_class['%'] = DASH
    elsif lang = pas then                       -- TURBO-PASCAL
      char_class['['] = BRACKET
      char_class[']'] = BRACKET
      char_class['('] = BRACKET
      char_class[')'] = BRACKET
      char_class['@'] = SPECIAL
      char_class['#'] = SPECIAL
      char_class['$'] = SPECIAL
      char_class['{'] = DASH
      char_class['}'] = DASH
      char_class['\''] = QUOTE
    end if
end procedure

sequence line                   -- the line being processed
integer seg_start, seg_end      -- start and end of current segment of line
integer color                   -- the current color

-- Ŀ
--  Wenn die Farbe wechselt, schreibe das aktuelle Segment.      
-- 
procedure flush(integer new_color)

    if new_color != color then
        if color != -1 then
            text_color(color)
            puts(SCREEN, line[seg_start..seg_end])
            seg_start = seg_end + 1
        end if
        color = new_color
    end if
end procedure

-- Ŀ
--  Zeige eine Zeile mit '\n' terminierte Zeile mit Farben an,   
--  die die verschiedenen Teile der Euphoria-Sprache wiedergeben 
--  Jeder Schreibvorgang hat eine Menge Overhead, deshalb wird   
--  die Anzahl die Items minimalisiert, indem aufeinanderfolgen- 
--  de Zeichen gleicher Farbe zu einem 'Segment' zusammengefasst 
--  werden: 'segment' seg_start..seg_end.                        
-- 
global procedure DisplayColorLine(sequence pline)
    
    integer class, last, i, c, bracket_level
    sequence word

    line = pline
    color = -1 -- initially undefined
    bracket_level = 0
    seg_start = 1
    seg_end = 0

    while 1 do
        c = line[seg_end+1]
        class = char_class[c]

        if class = WHITE_SPACE then
            seg_end = seg_end + 1 -- continue with same color

        elsif class = LETTER then
            last = length(line)-1
            for j = seg_end + 2 to last do
                c = line[j]
                class = char_class[c]
                if class != LETTER then
                    if class != DIGIT then
                        last = j - 1
                        exit
                    end if
                end if
            end for
            word = line[seg_end+1..last]
            if find(word, keywords) then
                flush(KEYWORD_COL)
            elsif find(word, builtins) then
                flush(BUILTIN_COL)
            else
                flush(FORE_COL)
            end if
            seg_end = last

        elsif class = SPECIAL then
            flush(SPECIAL_COL)
            seg_end = seg_end + 1
        
        elsif class <= OTHER then -- DIGIT too
            flush(FORE_COL)
            seg_end = seg_end + 1

        elsif class = BRACKET then
            if find(c, "([{") then
                bracket_level = bracket_level + 1
            end if
            if bracket_level >= 1 and
               bracket_level <= length(BRACKET_COL) then
                flush(BRACKET_COL[bracket_level])
            else
                flush(FORE_COL)
            end if
            if find(c, ")]}") then
                bracket_level = bracket_level - 1
            end if
            seg_end = seg_end + 1

        elsif class = NEW_LINE then
            exit  -- end of line
        
        elsif class = DASH then
            if lang = 0 then
              if line[seg_end+2] = '-' then
                  flush(COMMENT_COL)
                  seg_end = length(line)-1
                  exit
              end if
            else
              flush(COMMENT_COL)
              seg_end = length(line)-1
              exit
            end if
            flush(FORE_COL)
            seg_end = seg_end + 1

        else  -- QUOTE
            i = seg_end + 2
            while i < length(line) do
                if line[i] = c then
                    i = i + 1
                    exit
                elsif line[i] = '\\' then
                    if i < length(line)-1 then
                        i = i + 1 -- ignore escaped char
                    end if
                end if
                i = i + 1
            end while
            flush(STRING_COL)
            seg_end = i - 1
        end if
    end while

    if color != -1 then
        text_color(color)
    end if
    puts(SCREEN, line[seg_start..seg_end])
end procedure

-- 

